/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include "mwdg/mixer_hctl_editor.hpp"
#include <vector>

namespace MWdg
{

// Forward declaration
class Mixer_HCTL_Proxies_Group;

/// @brief Mixer_HCTL_Edit_Bool
///
class Mixer_HCTL_Edit_Bool : public Mixer_HCTL_Editor
{
  Q_OBJECT

  public:
  // -- Construction

  Mixer_HCTL_Edit_Bool ( Mixer_HCTL_Editor_Data * data_n,
                         QWidget * parent_n = nullptr );

  ~Mixer_HCTL_Edit_Bool ();

  // -- Setup

  void
  setup_single ();

  void
  setup_multi ();

  Mixer_HCTL_Proxies_Group *
  create_proxies_group ( QSnd::HCtl::Elem * elem_n );

  // -- Public slots

  Q_SLOT
  void
  update_proxies_values ();

  private:
  // -- Attributes
  std::vector< Mixer_HCTL_Proxies_Group * > _proxies_groups;
};

} // namespace MWdg
