/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include "mixer_hctl_proxy.hpp"
#include <QObject>

namespace MWdg
{

/// @brief Mixer_HCTL_Proxy_Switch
///
class Mixer_HCTL_Proxy_Switch : public Mixer_HCTL_Proxy
{
  Q_OBJECT

  public:
  // -- Construction

  Mixer_HCTL_Proxy_Switch ( QObject * parent_n );

  ~Mixer_HCTL_Proxy_Switch ();

  bool
  switch_state () const
  {
    return _switch_state;
  }

  // -- Signals

  Q_SIGNAL
  void
  sig_switch_state_changed ( bool state_n );

  // -- Public slots

  Q_SLOT
  void
  set_switch_state ( bool state_n );

  Q_SLOT
  void
  update_value_from_source ();

  protected:
  // -- Protected methods

  void
  switch_state_changed ();

  private:
  // -- Attributes
  bool _switch_state;
  bool _updating_state;
};

} // namespace MWdg
