/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include "mixer_hctl_int_proxy_slider.hpp"
#include "mwdg/slider_status_widget.hpp"

namespace MWdg
{

/// @brief Mixer_HCTL_Slider_Status_Widget
///
class Mixer_HCTL_Slider_Status_Widget : public Slider_Status_Widget
{
  Q_OBJECT

  public:
  // -- Construction

  Mixer_HCTL_Slider_Status_Widget ( QWidget * parent_n = nullptr );

  ~Mixer_HCTL_Slider_Status_Widget ();

  Mixer_HCTL_Int_Proxy_Slider *
  proxy_slider () const
  {
    return _proxy_slider;
  }

  // -- Element info

  QString
  elem_name () const;

  bool
  elem_has_volume () const;

  bool
  elem_has_dB () const;

  long
  elem_volume_value () const;

  void
  elem_set_volume ( long value_n ) const;

  long
  elem_volume_min () const;

  long
  elem_volume_max () const;

  long
  elem_dB_value () const;

  void
  elem_set_nearest_dB ( long dB_value_n ) const;

  long
  elem_dB_min () const;

  long
  elem_dB_max () const;

  // -- Slider selection

  void
  select_slider ( unsigned int grp_idx_n, unsigned int col_idx_n );

  // -- Protected slots
  protected:
  Q_SLOT
  void
  proxy_destroyed ();

  protected:
  // -- Protected methods

  void
  set_slider_proxy ( Mixer_HCTL_Int_Proxy_Slider * proxy_n );

  private:
  // -- Attributes
  Mixer_HCTL_Int_Proxy_Slider * _proxy_slider;
};

} // namespace MWdg
