/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include <QTime>

namespace MWdg
{

/// @brief Mixer_Separation_Info
///
class Mixer_Separation_Info
{
  public:
  // -- Construction

  Mixer_Separation_Info ();

  ~Mixer_Separation_Info ();

  // -- Separation

  bool
  requested () const
  {
    return _requested;
  }

  void
  set_requested ( bool flag_n )
  {
    _requested = flag_n;
  }

  bool
  do_it () const
  {
    return _do_it;
  }

  void
  set_do_it ( bool flag_n )
  {
    _do_it = flag_n;
  }

  const QTime &
  time () const
  {
    return _time;
  }

  void
  set_time ( const QTime & time_n )
  {
    _time = time_n;
  }

  private:
  // -- Attributes
  QTime _time;
  bool _requested;
  bool _do_it;
};

} // namespace MWdg
