/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include "qsnd/mixer/elem.hpp"
#include "wdg/pad_proxy_switch.hpp"

namespace MWdg
{

/// @brief Mixer_Sliders_Proxy_Switch
///
class Mixer_Sliders_Proxy_Switch : public Wdg::Pad_Proxy_Switch
{
  Q_OBJECT

  public:
  // -- Construction

  Mixer_Sliders_Proxy_Switch ();

  ~Mixer_Sliders_Proxy_Switch ();

  // -- Mixer element

  QSnd::Mixer::Elem *
  mixer_simple_elem () const
  {
    return _mixer_simple_elem;
  }

  void
  set_mixer_simple_elem ( QSnd::Mixer::Elem * selem_n );

  // -- Snd dir

  unsigned char
  snd_dir () const
  {
    return _snd_dir;
  }

  void
  set_snd_dir ( unsigned char dir_n );

  // -- Channel index

  unsigned int
  channel_idx () const
  {
    return _channel_idx;
  }

  void
  set_channel_idx ( unsigned int idx_n );

  // -- is joined

  bool
  is_joined () const
  {
    return _is_joined;
  }

  void
  set_is_joined ( bool flag_n );

  // -- Event processing

  bool
  eventFilter ( QObject * obj_n, QEvent * event_n ) override;

  // -- Public slots

  Q_SLOT
  void
  update_value_from_source ();

  protected:
  // -- Protected methods

  void
  switch_state_changed ();

  private:
  // -- Attributes
  QSnd::Mixer::Elem * _mixer_simple_elem;
  unsigned int _channel_idx;
  unsigned char _snd_dir;
  bool _is_joined;
  bool _alsa_updating;
};

} // namespace MWdg
