/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include <QMenu>
#include <QObject>
#include <QSystemTrayIcon>

/// @brief Tray_Mixer_Icon
///
class Tray_Mixer_Icon : public QSystemTrayIcon
{
  Q_OBJECT

  public:
  // -- Construction

  Tray_Mixer_Icon ( QObject * parent_n = nullptr );

  ~Tray_Mixer_Icon ();

  bool
  event ( QEvent * event_n ) override;

  // -- Public signals

  Q_SIGNAL
  void
  sig_hover ();

  Q_SIGNAL
  void
  sig_activated ();

  Q_SIGNAL
  void
  sig_middle_click ();

  Q_SIGNAL
  void
  sig_wheel_delta ( int delta_n );

  Q_SIGNAL
  void
  sig_quit ();

  // Protected slots
  protected:
  Q_SLOT
  void
  activation ( QSystemTrayIcon::ActivationReason reason_n );

  private:
  // -- Attributes
  QMenu _cmenu;
};
