/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include <QString>

/// @brief Tray_Mixer_MDev_Setup
///
class Tray_Mixer_MDev_Setup
{
  // Public typedefs
  public:
  enum Mixer_Device
  {
    MIXER_DEV_DEFAULT = 0,
    MIXER_DEV_CURRENT = 1,
    MIXER_DEV_USER = 2,
    MIXER_DEV_LAST = MIXER_DEV_USER
  };

  public:
  // -- Construction

  Tray_Mixer_MDev_Setup ();

  ~Tray_Mixer_MDev_Setup ();

  public:
  // -- Attributes
  /// @brief Which device to use for the mixer
  unsigned int device_mode = ::Tray_Mixer_MDev_Setup::MIXER_DEV_DEFAULT;

  /// @brief Mixer device of the main mixer window
  QString current_device;

  /// @brief User defined mixer device
  QString user_device;
};
