/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include <QDialog>
#include <QLabel>
#include <QPushButton>
#include <QVBoxLayout>

namespace Views
{

/// @brief Basic_Dialog
///
class Basic_Dialog : public QDialog
{
  Q_OBJECT

  public:
  Basic_Dialog ( QWidget * parent_n = nullptr,
                 Qt::WindowFlags flags_n = Qt::WindowFlags () );

  ~Basic_Dialog ();

  void
  set_title_str ( const QString & str_n );

  void
  set_central_widget ( QWidget * wdg_n );

  QLabel *
  create_title_widget ( const QString & txt_n );

  QPushButton *
  create_close_button ();

  private:
  // -- Attributes
  // Pages
  QLabel * _lbl_title;
  QVBoxLayout * _lay_main;
};

} // namespace Views
