/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include "basic_dialog.hpp"
#include <QListView>
#include <QModelIndex>
#include <QStackedLayout>
#include <QStandardItem>
#include <QStandardItemModel>

namespace Views
{

/// @brief Multi_Page_Dialog
///
class Multi_Page_Dialog : public Views::Basic_Dialog
{
  Q_OBJECT

  public:
  // -- Construction

  Multi_Page_Dialog ( QWidget * parent_n = nullptr,
                      Qt::WindowFlags flags_n = Qt::WindowFlags () );

  ~Multi_Page_Dialog ();

  // -- Setup

  void
  add_page_vscroll ( const QString & name_n, QWidget * wdg_n );

  void
  add_page ( const QString & name_n, QWidget * wdg_n );

  unsigned int
  num_pages () const;

  int
  current_page_idx () const;

  void
  set_current_page_idx ( int idx_n );

  // -- Protected slots
  protected:
  Q_SLOT
  void
  page_changed ( const QModelIndex & cur_n, const QModelIndex & prev_n );

  Q_SLOT
  void
  page_selected ( const QModelIndex & index_n );

  private:
  // -- Attributes
  // Pages
  QListView * _page_selection;
  QStackedLayout * _lay_pages_stack;
  QStandardItemModel * _pages_model;
};

} // namespace Views
