/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include <QPointer>
#include <QWidget>
#include <vector>

namespace Wdg
{

/// @brief Sliders_Pad_Header_Label
///
class Sliders_Pad_Header_Label
{
  public:
  // -- Construction

  Sliders_Pad_Header_Label ();

  ~Sliders_Pad_Header_Label ();

  public:
  // -- Attributes
  unsigned int label_length_max = 0;
  QTransform label_trans;
  QTransform label_trans_inv;
  QRectF label_rect;
  QRectF text_area;
  QRectF text_rect;
  QRect label_txt_bbox;

  unsigned int group_idx = 0;
  unsigned int column_idx = 0;
  unsigned int column_total_idx = 0;

  QString text;
  QString text_elided;
  QString tool_tip;

  QColor col_fg;
};

/// @brief Sliders_Pad_Header_Data
///
class Sliders_Pad_Header_Data
{
  public:
  // -- Construction

  Sliders_Pad_Header_Data ();

  ~Sliders_Pad_Header_Data ();

  bool update_elided_texts;
  bool update_decoration;
  bool upside_down;
  bool column_labels;
  bool label_sliding;

  std::vector< Sliders_Pad_Header_Label > labels;

  double angle;
  double angle_sin;
  double angle_cos;

  double center_x;
  double center_y;

  unsigned int max_str_length_px;

  unsigned int pad_left;
  unsigned int pad_right;
  unsigned int spacing_inter;
  unsigned int spacing_vertical;

  QPointer< QWidget > widget;
};

} // namespace Wdg
