/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include <QFrame>
#include <QScrollArea>

namespace Wdg
{

/// @brief Scroll area for a Switches_Pad
///
class Switches_Area : public QScrollArea
{
  public:
  // -- Construction

  Switches_Area ( QWidget * parent_n = nullptr );

  ~Switches_Area ();

  // -- Size hints

  QSize
  minimumSizeHint () const override;

  QSize
  sizeHint () const override;

  // -- Widget

  void
  set_widget ( QWidget * wdg_n );

  QWidget *
  take_widget ();

  protected:
  // -- Protected methods

  void
  resizeEvent ( QResizeEvent * event_n ) override;

  bool
  eventFilter ( QObject * watched_n, QEvent * event_n ) override;
};

} // namespace Wdg
