/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include <QLabel>
#include <QObject>
#include <memory>

namespace Wdg
{

/// @brief Switches_Pad_Widgets
///
class Switches_Pad_Widgets
{
  public:
  // -- Construction

  Switches_Pad_Widgets ();

  ~Switches_Pad_Widgets ();

  void
  clear_widgets ();

  // -- Input widget

  void
  set_input_wdg ( QWidget * wdg_n );

  QWidget *
  input_wdg ()
  {
    return _input.get ();
  }

  // -- Label widget

  QLabel *
  label_wdg ()
  {
    return _label.get ();
  }

  void
  set_label_wdg ( QLabel * wdg_n );

  private:
  // -- Attributes
  std::unique_ptr< QLabel > _label;
  std::unique_ptr< QWidget > _input;
};

} // namespace Wdg
